widget_quintupoltrobol/forum/urls.py
from django.urls import path
from .views import pageview, ForumpostDetailView, ForumpostCreateView, ForumpostUpdateView

urlpatterns = [
    path('', pageview, name='pageview'),
    path('forumposts/<int:pk>/details/', ForumpostDetailView.as_view(), name='forumpost-details'),
    path('forumposts/add/', ForumpostCreateView.as_view(), name='forumpost-add'),
    path('forumposts/<int:pk>/edit/', ForumpostUpdateView.as_view(), name='forumpost-edit'),
]

app_name = "forum"

widget_quintupoltrobol/widget_quintupoltrobol/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('', include('dashboard.urls', namespace="dashboard")),
    path('announcements/', include('announcements.urls', namespace="announcements")),
    path('forum/', include('forum.urls', namespace="forum")),
    path('assignments/', include('assignments.urls', namespace="assignments")),
    path('widget_calendar/', include('widget_calendar.urls', namespace="widget_calendar")),
    path('admin/', admin.site.urls),
]

widget_quintupoltrobol/forum/models.py
from django.db import models
from dashboard.models import WidgetUser
from django.urls import reverse

class ForumPost(models.Model):
    title = models.CharField(max_length=100)
    body = models.TextField()
    author = models.ForeignKey(WidgetUser, on_delete=models.CASCADE)
    pub_datetime = models.DateTimeField()
    
    def __str__(self):
        return self.title
    
    def get_absolute_url(self):
        return reverse("forum:forumpost-details", kwargs={"pk": self.pk})
    
class Reply(models.Model):
    body = models.TextField()
    author = models.ForeignKey(WidgetUser, on_delete=models.CASCADE)
    pub_datetime = models.DateTimeField()
    forum_post = models.ForeignKey(ForumPost, on_delete=models.CASCADE)
    
    def __str__(self):
        return self.body

widget_quintupoltrobol/forum/forms.py
from django import forms
from .models import ForumPost

class ForumpostForm(forms.ModelForm):
	class Meta:
		model = ForumPost
		fields = ['title', 'body', 'author']

widget_quintupoltrobol/forum/views.py
from django.shortcuts import render
from .models import ForumPost, Reply
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, UpdateView

def pageview(request):
    forumposts = ForumPost.objects.order_by("-pub_datetime")
    replys = Reply.objects.all()
    
    return render(request, 'forum/forum.html', {'forumposts': forumposts, 'replys': replys})
    
class ForumpostDetailView(DetailView):
    def get(self, request, pk):
        forumpost = ForumPost.objects.get(pk=pk)
        replys = Reply.objects.filter(forum_post=forumpost)
        return render(request, 'forum/forumpost-details.html', {'forumpost': forumpost, 'replys': replys})
        
class ForumpostCreateView(CreateView):
    model = ForumPost
    fields = '__all__'
    template_name = 'forum/forumpost-add.html'
    
class ForumpostUpdateView(UpdateView):
    model = ForumPost
    fields = '__all__'
    template_name = 'forum/forumpost-edit.html'

widget_quintupoltrobol/forum/templates/forum/forum.html
{% extends 'base.html' %}
{% load static %}
{% block title %}Widget's Forum{% endblock %}
{% block content %}
<h2>Welcome to Widget's Forum!</h2>
<h3>Forum posts:</h3>

{% for forumpost in forumposts %}
	<a href="{{ forumpost.get_absolute_url }}">{{ forumpost.title }} by {{ forumpost.author.last_name }}, {{ forumpost.author.first_name }}</a><br>

{% endfor %}

<br>

<form action={% url 'forum:forumpost-add' %}>
	<input type="submit" value="New Post"/>
</form>

<a href="{% url 'dashboard:pageview' %}">Dashboard</a><br>
<a href="{% url 'announcements:pageview' %}">Announcements</a><br>
<a href="{% url 'assignments:pageview' %}">Assignments</a><br>
<a href="{% url 'widget_calendar:pageview' %}">Calendar</a><br>
{% endblock %}

widget_quintupoltrobol/forum/templates/forum/forumpost-add.html
{% extends 'base.html' %}
{% load static %}
{% block title %}Add Post{% endblock %}
{% block content %}

<h2>Add a new post:</h2>
<p>
	<form action='' method="POST">
		{% csrf_token %}
		<table>
			{{ form.as_table }}
		</table>
		<input type="submit" value="Save New Post"/>
	</form>
</p>

{% endblock %}

widget_quintupoltrobol/forum/templates/forum/forumpost-details.html
{% extends 'base.html' %}
{% load static %}
{% block title %}{{ forumpost.title}} {% endblock %}
{% block content %}
<h2>{{ forumpost.title }}</h2>
<h3> by {{forumpost.author.first_name}} {{ forumpost.author.last_name }}</h3>
<p>{{forumpost.pub_datetime}}</p>

<br>
<p>{{forumpost.body}}</p>
<br>

<h2>POST REPLIES:</h2>
<br>

{% for reply in replys %}
	<h3> by {{reply.author.first_name}} {{ reply.author.last_name }}</h3>
	<p>{{reply.pub_datetime}}</p>
	<br>
	<p>{{reply.body}}</p>
	<br>
{% endfor %}

<button> <a href="{% url 'forum:forumpost-edit' forumpost.pk %}">Edit Post</a></button>

{% endblock %}

widget_quintupoltrobol/forum/templates/forum/forumpost-edit.html
{% extends 'base.html' %}
{% load static %}
{% block title %}Edit Post{% endblock %}
{% block content %}

<h2>Edit post:</h2>
<p>
	<form action='' method="POST">
		{% csrf_token %}
		<table>
			{{ form.as_table }}
		</table>
		<input type="submit" value="Save Changes to Post"/>
	</form>
</p>

{% endblock %}